function [] = Population()
clear; 
clc;
answer = inputdlg('How Many Repetitions?','',1,{'5'});
reps=str2double(answer);
[FileName,PathName] = uiputfile('*','What do you want to call the file? !!DO NOT TYPE IN .XLS OR .XLSX!!');
for i=1:reps
path=strcat(PathName,FileName,num2str(i));
runPopulation(path);
end
end
function [] = runPopulation(path)
%UNTITLED Summary of this function goes here
%   In order to change the number of runs, change reps. Currently  must be
%   <= 1000
%% setup
h = waitbar(0,'Please wait while the simulation initializes...');
model = 'Coupled_Model.mdl';
reps = 100;
time = randi(1000);
i=1;
Excel = actxserver ('Excel.Application'); 
File=path; 
if ~exist(File,'file') 
    ExcelWorkbook = Excel.workbooks.Add; 
    ExcelWorkbook.SaveAs(File,1); 
    ExcelWorkbook.Close(false); 
end 
invoke(Excel.Workbooks,'Open',File);
%% titles
titles1={'Spindle Length','Number of Motors'};
titles2={'left kMt1','left kMt2','left kMt3','left kMt4','left kMt5','left kMt6','left kMt7','left kMt8','left kMt9','left kMt10','left kMt11','left kMt12','left kMt13','leftkMt14','left kMt15','left kMt16','right kMt1','right kMt2','right kMt3','right kMt4','right kMt5','right kMt6','right kMt7','right kMt8','right kMt9','right kMt10','right kMt11','right kMt12','right kMt13','rightkMt14','right kMt15','right kMt16','','left kMts average','right kMts average'};
titles3={'Lspr1','Lspr2','Lspr3','Lspr4','Lspr5','Lspr6','Lspr7','Lspr8','Lspr9','Lspr10','Lspr11','Lspr12','Lspr13','Lspr14','Lspr15','Lspr16','','Lspr average'};
titles4={'pop1','pop2','pop3','pop4','pop5','pop6','pop7','pop8','pop9','pop10','pop11','pop12','pop13','pop14','pop15','pop16'};
xlswrite1(path,titles1,'Sheet1','A1');
xlswrite1(path,titles2,'Sheet2','A1');
xlswrite1(path,titles3,'Sheet3','A1');
xlswrite1(path,titles4,'Sheet4','A1');
%% main data
while i <= reps
    waitbar((i-1)/reps,h, strcat('Running Simulation',num2str(i),' of',num2str(reps)));
    simOut = sim(model,'SaveOutput','on');
    LipOut = simOut.find('LipOut');
xlswrite1(path,LipOut(time),'Sheet1',strcat('A',num2str(i+1)));
NmotorsOut = simOut.find('NmotorsOut');
xlswrite1(path,NmotorsOut(time),'Sheet1',strcat('B',num2str(i+1)));
kMtsOut = simOut.find('kMtsOut');
kMtsL=kMtsOut(time,1:2:end);
kMtsR=kMtsOut(time,2:2:end);
xlswrite1(path,{strcat('=AVERAGE(A',num2str(i+1),':P',num2str(i+1),')')},'Sheet2',strcat('AH',num2str(i+1)));
xlswrite1(path,{strcat('=AVERAGE(Q',num2str(i+1),':AF',num2str(i+1),')')},'Sheet2',strcat('AI',num2str(i+1)));
xlswrite1(path,kMtsL,'Sheet2',strcat('A',num2str(i+1)));
xlswrite1(path,kMtsR,'Sheet2',strcat('Q',num2str(i+1)));
allLsprOut = simOut.find('allLsprOut');
xlswrite1(path,allLsprOut(time,:),'Sheet3',strcat('A',num2str(i+1)));
xlswrite1(path,{strcat('=AVERAGE(A',num2str(i+1),':P',num2str(i+1),')')},'Sheet3',strcat('R',num2str(i+1)));
PoppedOut = simOut.find('PoppedOut');
xlswrite1(path,double(PoppedOut(time,:)),'Sheet4',strcat('A',num2str(i+1)));
xlswrite1(path,{strcat('=SUM(A',num2str(i+1),':P',num2str(i+1),')')},'Sheet4',strcat('R',num2str(i+1)));
    i=i+1;
end
waitbar(100/100,h,'Please wait while the file is written...');
%% calculations
nums=[0:16];
xlswrite1(path,nums,'Sheet4','T1');
count={'=COUNTIF($R$2:$R$1002,"0")','=COUNTIF($R$2:$R$1002,"1")','=COUNTIF($R$2:$R$1002,"2")','=COUNTIF($R$2:$R$1002,"3")','=COUNTIF($R$2:$R$1002,"4")','=COUNTIF($R$2:$R$1002,"5")','=COUNTIF($R$2:$R$1002,"6")','=COUNTIF($R$2:$R$1002,"7")','=COUNTIF($R$2:$R$1002,"8")','=COUNTIF($R$2:$R$1002,"9")','=COUNTIF($R$2:$R$1002,"10")','=COUNTIF($R$2:$R$1002,"11")','=COUNTIF($R$2:$R$1002,"12")','=COUNTIF($R$2:$R$1002,"13")','=COUNTIF($R$2:$R$1002,"14")','=COUNTIF($R$2:$R$1002,"15")','=COUNTIF($R$2:$R$1002,"16")'};
xlswrite1(path,count,'Sheet4','T2');
stretch={'1','=V3+V1','=W3+W1','=X3+X1','=Y3+Y1','=Z3+Z1','=AA3+AA1','=AB3+AB1','=AC3+AC1','=AD3+AD1','=AE3+AE1','=AF3+AF1','=AG3+AG1','=AH3+AH1','=AI3+AI1','=AJ3+AJ1'};
xlswrite1(path,stretch,'Sheet4','V3');
titles1={'both stretching';'one stretching'};
xlswrite1(path,titles1,'Sheet4','T4');
stretch2={'=V2*V3','=W2*W3','=X2*X3','=Y2*Y3','=Z2*Z3','=AA2*AA3','=AB2*AB3','=AC2*AC3','=AD2*AD3','=AE2*AE3','=AF2*AF3','=AG2*AG3','=AH2*AH3','=AI2*AI3','=AJ2*AJ3'};
xlswrite1(path,stretch2,'Sheet4','V4');
stretch1={'=V2*(16-V1)*V1','=W2*(16-W1)*W1','=X2*(16-X1)*X1','=Y2*(16-Y1)*Y1','=Z2*(16-Z1)*Z1','=AA2*(16-AA1)*AA1','=AB2*(16-AB1)*AB1','=AC2*(16-AC1)*AC1','=AD2*(16-AD1)*AD1','=AE2*(16-AE1)*AE1','=AF2*(16-AF1)*AF1','=AG2*(16-AG1)*AG1','=AH2*(16-AH1)*AH1','=AI2*(16-AI1)*AI1','=AJ2*(16-AJ1)*AJ1'};
xlswrite1(path,stretch1,'Sheet4','V5');
titles2={'1 Stretching','both stretching','','total','','all stretching events %'};
xlswrite1(path,titles2,'Sheet4','U7');
titles3={'N';'%';'';'';'N';'%'};
xlswrite1(path,titles3,'Sheet4','T8');
xlswrite1(path,{'if looking at single stretching'},'Sheet4','U11');
stuff1={'=(SUM(T5:AJ5))+U2','=SUM(T4:AJ4)','','=SUM(U8:V8)','',strcat('=X8/',num2str(120*reps))};
xlswrite1(path,stuff1,'Sheet4','U8');
stuff2={'=U8/X8','=V8/X8'};
xlswrite1(path,stuff2,'Sheet4','U9');
stuff3={'=SUM(A2:P1002)';strcat('=U12/',num2str(16*reps))};
xlswrite1(path,stuff3,'Sheet4','U12');
%overview
titlesOver = {'Lip','Lspr','Lkmt'};
Over = {'=AVERAGE(Sheet1!A2:A101)','=AVERAGE(Sheet3!A2:P101)','=AVERAGE(Sheet2!A2:AF101)'};
STD = {'=STDEV(Sheet1!A2:A101)','=STDEV(Sheet3!A2:P101)','=STDEV(Sheet2!A2:AF101)'};
xlswrite1(path,titlesOver,'Sheet5','A1');
xlswrite1(path,Over,'Sheet5','A2');
xlswrite1(path,STD,'Sheet5','A3');
%% close down
Excel.Quit 
Excel.delete 
clear Excel
close(h);
end

